package net.black_cow.opennip.ui.swing;

import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JLabel;

import net.black_cow.opennip.opennipcore.NipManager;
import net.black_cow.opennip.opennipcore.NipStone;

/**
 * jbṽ{[h\xNX.
 * @author percy
 *
 */
@SuppressWarnings("serial")
public class BoardLabel extends JLabel implements MouseListener {
	
	private Image white = new ImageIcon(this.getClass().getClassLoader().getResource(UIConstant.WHITE_GIF_PATH)).getImage();
	private Image black = new ImageIcon(this.getClass().getClassLoader().getResource(UIConstant.BLACK_GIF_PATH)).getImage();
	
	private Point[][] points = new Point[8][8];
	
	private MouseClickInfo info;
	
	/*
	 * W\NXB
	 */
	private class Point {
		private Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
		int x;
		int y;
		
		/*
		 * w肳ꂽWÃCX^XێWԓɂ邩ׂB
		 */
		boolean isInArea(int a, int b) {			
			return -UIConstant.DISTANCE_FROM_CENTER_TO_CATCH_CLICK < x-a && x-a < UIConstant.DISTANCE_FROM_CENTER_TO_CATCH_CLICK
				&& -UIConstant.DISTANCE_FROM_CENTER_TO_CATCH_CLICK < y-b && y-b < UIConstant.DISTANCE_FROM_CENTER_TO_CATCH_CLICK;
		}
	}
	
	/*
	 * RXgN^B
	 */
	BoardLabel(ImageIcon icon, MouseClickInfo info) {
		super(icon);
		init();
		this.info = info;
		addMouseListener(this);
	}
	
	/*
	 * B
	 * zpoints쐬B
	 */
	private void init() {
		points[0][2] = new Point(UIConstant.POS_COL[3], UIConstant.POS_ROW[1]);
		points[0][3] = new Point(UIConstant.POS_COL[4], UIConstant.POS_ROW[0]);
		points[0][4] = new Point(UIConstant.POS_COL[5], UIConstant.POS_ROW[0]);
		points[0][5] = new Point(UIConstant.POS_COL[6], UIConstant.POS_ROW[1]);
		
		for(int j=1; j<=6; j++) {
			points[1][j] = new Point(UIConstant.POS_COL[j+1], UIConstant.POS_ROW[2]);
			points[6][j] = new Point(UIConstant.POS_COL[j+1], UIConstant.POS_ROW[7]);
		}
		points[2][0] = new Point(UIConstant.POS_COL[1], UIConstant.POS_ROW[3]);
		points[3][0] = new Point(UIConstant.POS_COL[0], UIConstant.POS_ROW[4]);
		points[4][0] = new Point(UIConstant.POS_COL[0], UIConstant.POS_ROW[5]);
		points[5][0] = new Point(UIConstant.POS_COL[1], UIConstant.POS_ROW[6]);
		for(int i=2; i<=5; i++) {
			for(int j=1; j<=6; j++) {
				points[i][j] = new Point(UIConstant.POS_COL[j+1], UIConstant.POS_ROW[i+1]);
			}
		}
		points[2][7] = new Point(UIConstant.POS_COL[8], UIConstant.POS_ROW[3]);
		points[3][7] = new Point(UIConstant.POS_COL[9], UIConstant.POS_ROW[4]);
		points[4][7] = new Point(UIConstant.POS_COL[9], UIConstant.POS_ROW[5]);
		points[5][7] = new Point(UIConstant.POS_COL[8], UIConstant.POS_ROW[6]);
		
		points[7][2] = new Point(UIConstant.POS_COL[3], UIConstant.POS_ROW[8]);
		points[7][3] = new Point(UIConstant.POS_COL[4], UIConstant.POS_ROW[9]);
		points[7][4] = new Point(UIConstant.POS_COL[5], UIConstant.POS_ROW[9]);
		points[7][5] = new Point(UIConstant.POS_COL[6], UIConstant.POS_ROW[8]);
	}
	
	/*
	 * NipManagerNXTablȅ擾A{[h`悷B
	 * Q[JnɕK͎sKvB
	 */
	void refresh(NipManager manager) {
		paintComponent(this.getGraphics());
		for(int i = 0; i <= 7; i++) {
			for(int j = 0; j <= 7; j++) {
				if(!(((i==0 || i==7) && (j<=1||j>=6)) || ((i==1 || i==6) && (j==0||j==7))) ) {
					this.getGraphics().drawImage(convertColorToImage(manager.getCellColor(i, j)), points[i][j].x + UIConstant.POS_COL_DIF, points[i][j].y + UIConstant.POS_ROW_DIF, this);
				}
			}
		}
	}
	
	/*
	 * w肳ꂽʒuɁAw肳ꂽF`悷B
	 */
	void paint(int row, int column, NipStone.Color color) {
		this.getGraphics().drawImage(convertColorToImage(color), points[row][column].x + UIConstant.POS_COL_DIF, points[row][column].y + UIConstant.POS_ROW_DIF, this);
	}
	
	/*
	 * ColorΉImageCX^XԂB
	 */
	private Image convertColorToImage(NipStone.Color color) {
		if(color == null) return null;
		return color.equals(NipStone.Color.BLACK) ? black : white;
	}
	
	/*
	 * }EXNbN̍WZ̃CfbNXɕϊAMouseClickInfoCX^XɊi[B
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	@Override
	public void mouseClicked(MouseEvent e) {
		int[] nearestPoint = getNearestPoint(e.getX(), e.getY());
		info.setInfo(nearestPoint[0], nearestPoint[1]);
	}
	
	/*
	 * w肳ꂽWA̍W܂܂Z̃CfbNXԂB
	 */
	private int[] getNearestPoint(int x, int y) {
		for(int i=0; i<=7; i++) {
			for(int j=0; j<=7; j++) {
				if(points[i][j] != null && points[i][j].isInArea(x, y)) {
					return new int[]{i, j};
				}
			}
		}
		return new int[]{0, 0};
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// nothing to do.
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// nothing to do.
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// nothing to do.
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// nothing to do.
	}
}
