package net.black_cow.opennip.ui.swing;

import java.applet.Applet;
import java.applet.AudioClip;

import net.black_cow.opennip.opennipcore.NipObserver;
import net.black_cow.opennip.opennipcore.NipPlayer;
import net.black_cow.opennip.opennipcore.NipStone;
import net.black_cow.opennip.opennipcore.NipStone.Color;

/**
 * NipObserver̎NX.
 * <p>
 * OpenNipCorẽCxgʒm󂯁AOpenNipUICX^XUIXṼbZ[W𑗂B
 * </p>
 * @author percy
 *
 */
public class ConcreteNipObserver implements NipObserver {

	private OpenNipUI ui;	
	private AudioClip stonePutSound;
	
	/*
	 * RXgN^.
	 */
	ConcreteNipObserver(OpenNipUI ui) {
		this.ui = ui;
		stonePutSound = Applet.newAudioClip(this.getClass().getClassLoader().getResource("sound.wav"));
	}
	
	private void playSound() {
		if(UIConstant.SOUND_ON) {
			stonePutSound.play();
		}
	}
	
	@Override
	public void onBothPlayersCannotPutStone() {
		ui.setMessage(UIConstant.BOTH_PLAYERS_CANNOT_PUT_STONE_MESSAGE);	
		ui.showDialog(UIConstant.BOTH_PLAYERS_CANNOT_PUT_STONE_MESSAGE, UIConstant.DESCIPTION_LIFE_TIME, UIConstant.DESCRIPTION_FONT, null);
	}

	@Override
	public void onGameEnd(NipPlayer winner, int winnerScore, int loserScore) {
		if(winner == null) {
			ui.setMessage("Q[II" + winnerScore + "" + loserScore + "ňłB");
			ui.showDialog("<html>Q[II<br>" + winnerScore + "" + loserScore + "ňłB</html>", UIConstant.DESCIPTION_LIFE_TIME, UIConstant.DESCRIPTION_FONT, null);
		} else {
			String color = winner.getColor().equals(NipStone.Color.BLACK) ? "" : "";
			ui.setMessage("Q[II" + winnerScore + "" + loserScore + "" + color + "̏B");
			ui.showDialog("<html>Q[II<br>" + winnerScore + "" + loserScore + "" + color + "̏B</html>", UIConstant.DESCIPTION_LIFE_TIME, UIConstant.DESCRIPTION_FONT, null);
		}
	}

	@Override
	public void onGameStart() {
		ui.refresh();
		ui.setMessage(UIConstant.GAME_START_MESSAGE);
		ui.showDialog(UIConstant.GAME_START_MESSAGE, UIConstant.GAME_START_MESSAGE_LIFE_TIME, UIConstant.GAME_START_FONT, null);
	}

	@Override
	public void onNewStone(int row, int column, Color color) {
		ui.drawBoard(row, column, color);
		playSound();
		ui.incrementScore(color);
		ui.refreshInformation();
		try {
			Thread.sleep(UIConstant.WAIT_TIME);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void onNoPlaceToPut(NipPlayer player) {
		String color = player.getColor().equals(NipStone.Color.BLACK) ? "" : "";
		String other = player.getColor().equals(NipStone.Color.WHITE) ? "" : "";
		ui.setMessage(color + "͒uꏊȂ߁A" + other + "Ƀ^[ڂ܂B");
		ui.showDialog("<html>" + color + "͒uꏊȂ߁A<br>" + other + "Ƀ^[ڂ܂B</html>", UIConstant.DESCIPTION_LIFE_TIME, UIConstant.DESCRIPTION_FONT, null);
	}

	@Override
	public void onPlayerTurn(NipPlayer player) {
		String color = player.getColor().equals(NipStone.Color.BLACK) ? "" : "";
		ui.setMessage(color + "̃^[B");
	}

	@Override
	public void onStoneColorChanged(int row, int column, Color color) {
		ui.drawBoard(row, column, color);
		playSound();
		ui.incrementScore(color);
		ui.decrementScore(color.equals(NipStone.Color.BLACK) ? NipStone.Color.WHITE : NipStone.Color.BLACK);
		ui.refreshInformation();
		try {
			Thread.sleep(UIConstant.WAIT_TIME);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void onStoneColorChangedFinished() {
		// nothing to do.
	}

}
