package net.black_cow.opennip.ui.swing;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

@SuppressWarnings("serial")
public class MessageModalDialog extends JDialog implements ActionListener {

	private JLabel message;
	
	private Object reply;
	
	public MessageModalDialog(JFrame owner, JButton... buttons) {
		super(owner, true);
		
		JPanel panel = new JPanel();
		panel.setBackground(UIConstant.MESSAGE_DIALOG_PANEL_COLOR);
		panel.setPreferredSize(UIConstant.MESSAGE_MODAL_DIALOG_PANEL_SIZE);
		
		panel.setLayout(new FlowLayout());
		
		message = new JLabel();
		message.setHorizontalAlignment(JLabel.CENTER);
		message.setVerticalAlignment(JLabel.CENTER);
		message.setPreferredSize(UIConstant.MESSAGE_MODAL_DIALOG_MESSAGE_SIZE);
		
		panel.add(message);
		
		for(JButton button : buttons) {
			button.addActionListener(this);
			panel.add(button);
		}
		
		this.add(panel);
		this.pack();
		this.setResizable(false);
		this.setLocationRelativeTo(owner);
	}
	
	void setText(String message, Font font, Color textColor) {
		this.message.setFont(font);
		this.message.setForeground(textColor);
		this.message.setText(message);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		reply = e.getSource();
		this.setVisible(false);
	}
	
	Object getReply() {
		return reply;
	}
}
