package net.black_cow.opennip.ui.swing;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;

/**
 * 萔NX.
 * @author percy
 *
 */
public class UIConstant {

	static {
		Properties props = new Properties();
		try {
			String jarPath = System.getProperty("java.class.path");
			String dirPath = jarPath.substring(0, jarPath.lastIndexOf(File.separator)+1);
			props.load(new FileInputStream(dirPath + "settings.properties"));
			WAIT_TIME = Long.parseLong(props.getProperty("WAIT_TIME"));
			SOUND_ON = props.getProperty("SOUND").equals("ON") ? true : false;
		} catch (Exception e) {
			e.printStackTrace();
			WAIT_TIME = 350;
			SOUND_ON = true;
		}
	}

	final static String FRAME_TITLE = "OpenNip";

	final static Color BOARD_PANEL_COLOR = Color.BLUE;
	final static Color INFORMATION_PANEL_COLOR = new Color(204, 255, 204);
	final static Color MESSAGE_PANEL_COLOR = new Color(204,255,255);
	final static Color MESSAGE_DIALOG_PANEL_COLOR = new Color(204,255,255);

	final static String BOARD_GIF_PATH = "Board.gif";
	final static String WHITE_GIF_PATH = "White.gif";
	final static String BLACK_GIF_PATH = "Black.gif";

	final static String TEXT_AREA_WHITE = "White";
	final static String TEXT_AREA_BLACK = "Black";
	final static String TEXT_AREA_CENTER = "-";

	final static Font INFORMATION_FONT = new Font("Century", Font.BOLD, 30);
	final static Font MESSAGE_FONT = new Font("MS SVbN", Font.BOLD, 30);

	final static Dimension BOARD_PANEL_SIZE = new Dimension(775, 720);
	final static Dimension INFORMATION_PANEL_SIZE = new Dimension(775, 70);
	final static Dimension MESSAGE_PANEL_SIZE = new Dimension(775, 60);
	final static Dimension MESSAGE_DIALOG_PANEL_SIZE = new Dimension(500, 200);
	final static Dimension MESSAGE_MODAL_DIALOG_MESSAGE_SIZE = new Dimension(500, 120);
	final static Dimension MESSAGE_MODAL_DIALOG_PANEL_SIZE = new Dimension(500, 160);
	final static Dimension BUTTON_SIZE = new Dimension(100, 35);

	final static int[] POS_ROW = {43, 63, 134, 220, 307, 393, 480, 566, 637, 657};
	final static int[] POS_COL = {74, 94, 165, 252, 338, 426, 512, 598, 669, 689};

	final static int POS_ROW_DIF = -48;
	final static int POS_COL_DIF = -48;

	final static int DISTANCE_FROM_CENTER_TO_CATCH_CLICK = 25;

	final static long TITLE_MESSAGE_LIFE_TIME = 1500;
	final static long GAME_START_MESSAGE_LIFE_TIME = 1500;
	final static long DESCIPTION_LIFE_TIME = 1800;
	final static long CPU_WAIT_TIME = 200;

	final static Font TITLE_MESSAGE_FONT = new Font("Century", Font.BOLD, 70);
	final static Font GAME_START_FONT = new Font("MS SVbN", Font.BOLD, 50);
	final static Font DESCRIPTION_FONT = new Font("MS SVbN", Font.BOLD, 30);

	final static String TITLE_MESSAGE = "OpenNip";
	final static String GAME_START_MESSAGE = "Q[X^[gI";
	final static String BOTH_PLAYERS_CANNOT_PUT_STONE_MESSAGE = "ҒuꏊȂ߁AQ[IłB";
	final static String ASK_REPLAY_MESSAGE = "xVт܂H";

	final static Color TITLE_MESSAGE_COLOR = new Color(51, 51, 255);

	final static String YES_BUTTON_TEXT = "͂";
	final static String NO_BUTTON_TEXT = "";

	final static String MAN_BUTTON_TEXT = "l";
	final static String WEAK_BUTTON_TEXT = "CPUij";
	final static String MID_BUTTON_TEXT = "CPUij";
	final static String STRONG_BUTTON_TEXT = "CPUij";

	final static String ASK_FIRST_PLAYER_TEXT = "<html>ij̃vC[<br>IłB</html>";
	final static String ASK_SECOND_PLAYER_TEXT = "<html>ij̃vC[<br>IłB</html>";

	static long WAIT_TIME;
	static boolean SOUND_ON;

}
