package net.black_cow.opennip.opennipcore;

import java.util.ArrayList;
import java.util.List;

/**
 * jbvQ[̐isǗNX.
 * @author percy
 *
 */
public class NipManager {

	private NipPlayer first;
	private NipPlayer second;
	private NipTable table;
	private NipPlayer currentPlayer;
	
	private List<NipObserver> observers = new ArrayList<NipObserver>();
	
	/**
	 * RXgN^.
	 * @param first vC[iF͍j
	 * @param second vC[iF͔j
	 */
	public NipManager(NipPlayer first, NipPlayer second) {
		this.first = first;
		this.second = second;
		table = new NipTable();
		table.initTable();
		first.init(table, NipStone.Color.BLACK, second);
		second.init(table, NipStone.Color.WHITE, first);
		currentPlayer = first;
	}
	
	/**
	 * IuU[oǉB
	 * @param observer IuU[o
	 */
	public void addObservers(NipObserver observer) {
		observers.add(observer);
		table.addObservers(observer);
	}
	
	/**
	 * Q[Jn.
	 */
	public void play() {
		notifyObserversOnGameStart(table);
		while(table.getBlankCellCount() != 0 && table.getStoneCount(NipStone.Color.BLACK) != 0 && table.getStoneCount(NipStone.Color.WHITE) != 0) {
			notifyObserversPlayerTurn(currentPlayer);
			if(currentPlayer.canPutStone()) {
				currentPlayer.putStone();
			} else {
				if(!currentPlayer.getAnotherPlayer().canPutStone()) {
					notifyBothPlayersCannotPutStone();
					break;
				}
				notifyObserversOnNoPlaceToPut(currentPlayer);
			}
			currentPlayer = currentPlayer.getAnotherPlayer();
		}
		judgeAndNotifyResult();
	}
	
	/**
	 * w肵Z̐FԂ.
	 * 
	 * @param row Z̍s̈ʒu
	 * @param column Z̗̈ʒu
	 * @return Z̐Fi΂ꍇnullj
	 */
	public NipStone.Color getCellColor(int row, int column) {
		return table.getCellColor(row, column);
	}
	
	/**
	 * w肵F̐΂̐Ԃ.
	 * @param color ΂̐F
	 * @return 
	 */
	public int getStoneCount(NipStone.Color color) {
		return table.getStoneCount(color);
	}
		
	/*
	 * Q[ʂ̔ƒʒmsB
	 */
	private void judgeAndNotifyResult() {
		int firstPlayerScore = table.getStoneCount(NipStone.Color.BLACK);
		int secondPlayerScore = table.getStoneCount(NipStone.Color.WHITE);
		if(firstPlayerScore > secondPlayerScore) {
			notifyObserversOnGameEnd(first, firstPlayerScore, secondPlayerScore);
		} else if(firstPlayerScore < secondPlayerScore) {
			notifyObserversOnGameEnd(second, secondPlayerScore, firstPlayerScore);
		} else {
			notifyObserversOnGameEnd(null, firstPlayerScore, secondPlayerScore);
		}
	}
	
	/*
	 * Q[̊JnʒmB
	 */
	private void notifyObserversOnGameStart(NipTable table) {
		for(NipObserver observer : observers) {
			observer.onGameStart();
		}
	}
	
	/*
	 * Q[̏IʒmB
	 */
	private void notifyObserversOnGameEnd(NipPlayer winner, int winnerScore, int loserScore) {
		for(NipObserver observer : observers) {
			observer.onGameEnd(winner, winnerScore, loserScore);
		}
	}
	
	/*
	 * vC[̃^[ƂȂƂʒmB
	 */
	private void notifyObserversPlayerTurn(NipPlayer player) {
		for(NipObserver observer : observers) {
			observer.onPlayerTurn(player);
		}
	}
	
	/*
	 * ΂ꏊȂ߁A^[ڂ邱ƂʒmB
	 */
	private void notifyObserversOnNoPlaceToPut(NipPlayer player) {
		for(NipObserver observer : observers) {
			observer.onNoPlaceToPut(player);
		}
	}
	
	/*
	 * vC[΂uȂȂƂʒmB
	 */
	private void notifyBothPlayersCannotPutStone() {
		for(NipObserver observer : observers) {
			observer.onBothPlayersCannotPutStone();
		}
	}
	
}
