package net.black_cow.opennip.opennipcore;

import java.util.ArrayList;
import java.util.List;

/**
 * NipTableNXɊւ郆[eBeB\bh񋟂NX.
 * @author percy
 *
 */
public class NipTableUtil {

	/**
	 * w肳ꂽ΂w肳ꂽe[ûꂩ̃ZɒuƂłꍇtrueԂ.
	 * @param table e[u
	 * @param stone 
	 * @return w肳ꂽ΂w肳ꂽe[ûꂩ̃ZɒuƂłꍇtrue
	 */
	public static boolean canPutStone(NipTable table, NipStone stone) {
		return table.canPutStone(stone);
	}

	/**
	 * w肳ꂽe[uQ[IԂ肷.
	 * @param table e[u
	 * @return Q[IԂłꍇtrue
	 */
	public static boolean isFinished(NipTable table) {
		return !table.canPutStone(new NipStone(NipStone.Color.BLACK)) && !table.canPutStone(new NipStone(NipStone.Color.WHITE));
	}

	/**
	 * w肳ꂽ΂uƂł邷ׂẴZ̃CfbNXz̃XgԂ.
	 * @param table e[u
	 * @param stone u
	 * @return CfbNXz̃Xg
	 */
	public static List<int[]> getCanPutStoneCellList(NipTable table, NipStone stone) {
		List<int[]> list = new ArrayList<int[]>();
		for(int i=0; i<=7; i++) {
			for(int j=0; j<=7; j++) {
				if(table.canPutStoneAt(i, j, stone)) {
					list.add(new int[] {i, j});
				}
			}
		}
		return list;
	}

	/**
	 * w肳ꂽ΂uƂłZ̑Ԃ.
	 * @param table e[u
	 * @param stone u
	 * @return w肳ꂽ΂uƂłZ̑
	 */
	public static int getCanPutStoneCellCount(NipTable table, NipStone stone) {
		int counter = 0;
		for(int i=0; i<=7; i++) {
			for(int j=0; j<=7; j++) {
				if(table.canPutStoneAt(i, j, stone)) {
					counter++;
				}
			}
		}
		return counter;
	}

	/**
	 * e[uɂw肳ꂽF̐΂uĂZ̐Ԃ.
	 * <p>
	 * colornullƁA΂uĂȂZ̐ԂB
	 * </p>
	 * @param table e[u
	 * @param color w肳ꂽF
	 * @return Z̐
	 */
	public static int getStoneCount(NipTable table, NipStone.Color color) {
		if(color == null) return table.getBlankCellCount();

		return table.getStoneCount(color);
	}

	/**
	 * w肳ꂽʒuɐ΂úAXṼe[uԂ.
	 * @param table ΂ue[u
	 * @param row s̈ʒu
	 * @param column ̈ʒu
	 * @param stone u
	 * @return ΂ũe[u
	 */
	public static NipTable ifYouPutStoneAt(NipTable table, int row, int column, NipStone stone) {
		NipTable copy = table.getCopy();
		copy.putStoneAt(row, column, stone);
		return copy;
	}

	/**
	 * w肵F̐΂Ԃ.
	 * @param color ΂̐F
	 * @return 
	 */
	public static NipStone newStone(NipStone.Color color) {
		return new NipStone(color);
	}

	/**
	 * w肵΂Ƃ͈قȂF̐΂Ԃ.
	 * @param stone w肷
	 * @return w肵΂Ƃ͈قȂF̐
	 */
	public static NipStone differentColorStone(NipStone stone) {
		return new NipStone(stone.getColor().equals(NipStone.Color.BLACK) ? NipStone.Color.WHITE : NipStone.Color.WHITE);
	}

	/**
	 * w肳ꂽ]l}bvɊÂ]lvZ.
	 * @param table ]ΏۂƂȂe[u
	 * @param color ]ΏۂƂȂ΂̐F
	 * @param map ]l}bv
	 * @return ]l
	 */
	public static int evaluate(NipTable table, NipStone.Color color, int[][] map) {
		int evaluation = 0;
		for(int i=0; i<=7; i++) {
			for(int j=0; j<=7; j++) {
				if(!(((i==0 || i==7) && (j<=1||j>=6)) || ((i==1 || i==6) && (j==0||j==7))) && table.getCellColor(i, j) != null) {
					evaluation += table.getCellColor(i, j).equals(color) ? map[i][j] : -map[i][j];
				}
			}
		}
		return evaluation;
	}
}
