package net.black_cow.opennip.strategy;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import net.black_cow.opennip.opennipcore.NipStone;
import net.black_cow.opennip.opennipcore.NipStrategy;
import net.black_cow.opennip.opennipcore.NipTable;
import net.black_cow.opennip.opennipcore.NipTableUtil;

/**
 * ɍł擾ł΂̐őɂI헪.
 * @author percy
 *
 */
public class OneStepMaximizeStrategy implements NipStrategy {

	private Random rand;
	private long waitTime;

	/**
	 * RXgN^.
	 * @param waitTime ҋ@ԁi~bj
	 */
	public OneStepMaximizeStrategy(long waitTime) {
		rand = new Random();
		this.waitTime = waitTime;
	}

	@Override
	public int[] decide(NipTable table, NipStone stone) {
		List<int[]> list = NipTableUtil.getCanPutStoneCellList(table, stone);

		List<int[]> bestWays = new ArrayList<int[]>();
		int bestScore = 0;

		for(int[] index : list) {
			int score = NipTableUtil.getStoneCount(NipTableUtil.ifYouPutStoneAt(table, index[0], index[1], stone), stone.getColor());
			if(score > bestScore) {
				bestWays.clear();
				bestWays.add(index);
				bestScore = score;
			} else if (score == bestScore) {
				bestWays.add(index);
			}
		}
		try {
			Thread.sleep(waitTime);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		return bestWays.get(rand.nextInt(bestWays.size()));
	}

}
